((Drupal, math) => {
  Drupal.behaviors.formMathElementCalculator = {
    attach: () => {

      function calc(fieldElement) {
        // fieldElement.classList.add('built');
        const fieldNames = fieldElement.dataset.evaluateFields.split(' ');
        const expression = fieldElement.dataset.evaluateExpression;
        const formContext = fieldElement.dataset.evaluateContext;
        const deepFields = JSON.parse(fieldElement.dataset.evaluateDeepFields) || {};

        function handleFieldChange (e) {
          const convertedExpression = fieldNames.reduce((exp, field) => {
            const currentElement = document.querySelector(`input[name="${field}"], select[name="${field}"]`);
            let currentFieldValue;
            if (currentElement === null && deepFields[field] !== undefined) {
              currentFieldValue = deepFields[field];
            }
            else {
              currentFieldValue = currentElement.value;
            }
            if (currentFieldValue !== '') {
              return exp.replaceAll(`:${field}`, currentFieldValue);
            }
            return exp;
          }, expression);
          if (convertedExpression.split(':').length === 1) {
            fieldElement.value = math.evaluate(convertedExpression);
            fieldElement.dispatchEvent(new Event('change'));
          }
        }
        fieldNames.forEach(name => {
          const element = document.querySelector(`form#${formContext} input[name="${name}"], select[name="${name}"]`);
          if (element) {
            element.removeEventListener('change', handleFieldChange);
            element.addEventListener('change', handleFieldChange);
          }
        });
      }

      document
        .querySelectorAll('.js-calc-field:not(.built)')
        .forEach(el => {
          if (
            el.dataset.evaluateFields !== undefined &&
            el.dataset.evaluateExpression !== undefined
          ) {
            try {
              calc(el);
            }
            catch (e) {
              console.error(`Failed to calculate ${e}`);
            }
          }
        })
    },
  }
})(Drupal, math);
