<?php

namespace Drupal\webform_calculation_fields\Plugin\WebformElement;

use Drupal\Core\Form\FormStateInterface;
use Drupal\webform\Plugin\WebformElement\Number;

/**
 * Provides a 'Webform Remote Fields Hidden' element.
 *
 * @WebformElement(
 *   id = "form_element_math",
 *   label = @Translation("Field calculator"),
 *   api = "https://api.drupal.org/api/drupal/core!lib!Drupal!Core!Render!Element!Number.php/class/Number",
 *   description = @Translation("Provides a hidden form element with API Integration."),
 *   category = @Translation("Calculator"),
 * )
 */
class WebformFieldCalculator extends Number {


  public function defineDefaultProperties() {
    return parent::defineDefaultProperties() + [
      'evaluation_fields' => '',
    ];
  }

  public function form(array $form, FormStateInterface $form_state) {
    $form = parent::form($form, $form_state);

    $form['options']['calculator'] = [
      '#type' => 'details',
      '#title' => 'Calculator settings',
      '#weight' => -1,
    ];

    $form['options']['calculator']['evaluation_fields'] = [
      '#type' => 'textarea',
      '#title' => $this->t('Add here the expression'),
      '#description' => $this->t('Example of expressions: field_1 + field_2 - (field_1 * field_3)'),
      '#weight' => 1,
    ];

    return $form;
  }

}
